#!/bin/sh

# HK2K2 TV 3D SWITCH SCRIPT
# V1, 080112
# tested on following TVs:

# LG47LD950 9600baud
#############################

#common variables

#set used comport
comport=/dev/ttyS0

#set baudrate for TV communication (see table above)
baud=9600 #change for your TV

#############################

#specific variables:

# LG47LD950 screenformat for normal TV operation
# 01 : Normal anzeige (4:3)
# 02 : Breit anzeige (16:9)
# 04 : Zoom
# 06 : Original
# 07 : 14:9
# 09 : Just Scan
# 0B : Voll-Breitbild
# 10 bis 1F :Kino- Zoom 1 bis 16

screen=09


#############################


MODE=$1

oldspeed=`stty -F $comport | grep speed | awk -F" " '{ print $2 }' 2>/dev/null`
if [ "$oldspeed" != "$baud" ]; then
	echo "Baudrate is," $oldspeed ", and not OK! setting correct baudrate:"
	stty -F $comport $baud
	newspeed=`stty -F $comport | grep speed | awk -F" " '{ print $2 }' 2>/dev/null`
	echo "Baudrate is now" $newspeed ", and OK!"
else
echo "Baudrate is" $oldspeed "and OK!"
fi
echo "Request mode: " $MODE

if [ "$MODE" = "off" ];then
	echo "Switch command: 3D off"
	echo "mc 1 DC" >> $comport
	echo "mc 1 28" >> $comport
	echo "kc 1" $screen >> $comport
	sleep 1
	echo "mc 1 28" >> $comport
	
elif [ "$MODE" = "sbs" ]; then
	echo "Switch command: 3D SBS (L/R)"
	echo "mc 1 DC" >> $comport
	echo "mc 1 44" >> $comport
	sleep 1
	echo "mc 1 44" >> $comport
else
	echo "Incorrect or missing Parameter"
fi

if [ "$oldspeed" != "$baud" ]; then
	echo "Setting baudrate back to," $oldspeed
	stty -F $comport $oldspeed
fi

exit